#include <stdlib.h>
#include <stdio.h>
#include <GL/glut.h>
#include <math.h>

/* Parametres */
/* Part of the arm that moves */
#define TOP 0
#define MIDDLE 1
#define BOTTOM 2
int objectMoving = 2; /* quel morceau du bras on bouge   */

float rotations[3];
float length[3];

/* Pr interface utilisateur */
int beginx, beginy, width, height;
float beginAngle;
float tmin;



void drawObject()
{
  float x, y;
  float x0, y0;
  float radius = 0.1;
  float tmax = 1 - tmin; 
  float angle = 0;
  int i;

  glPushMatrix();
  x = -1.0;
  y = -0.5;

  /* Drawing the skeletton: */
  glColor3f(1.0, 0.0, 0.0);
  glLineWidth(5.0);
  glBegin(GL_LINES);
  /* Je vous ai laisse du travail */
  glEnd();
  /* Et les articulations */
  glPointSize(10.0);
  glColor3f(1.0, 1.0, 0.0);
  glBegin(GL_POINTS);
  /* ...  */
  glEnd();

  // The drawing of the "flesh"
  glColor3f(0.0, 0.0, 1.0);
  glLineWidth(2.0);
  /* ...  */
  
  glPopMatrix();
}

void handle_main_menu(int item)
{
  switch(item) {
  case TOP:
    objectMoving = 0;
    glutPostRedisplay();
    break;
  case MIDDLE:
    objectMoving = 1;
    glutPostRedisplay();
    break;
  case BOTTOM:
    objectMoving = 2;
    break;
  }
}

void
mouse(int button, int state, int x, int y)
{
  if (state == GLUT_DOWN) {
    beginx = x;
    beginy = y;
    beginAngle = rotations[objectMoving];
  }
  glutPostRedisplay();
}

void
motion(int x, int y)
{
  rotations[objectMoving] = beginAngle + (y - beginy)/(float)width;
  glutPostRedisplay();
}

void parsekey(unsigned char key, int x, int y)
{
  switch (key)
    {
    case 27: exit(0);
    case ' ': 
      rotations[0] = 0.0;
      rotations[1] = 0.0;
      rotations[2] = 0.0;
      break;
    case 'a': objectMoving = TOP; break;
    case 'z': objectMoving = MIDDLE; break;
    case 'e': objectMoving = BOTTOM; break;
    default:
      return;
    }
  glutPostRedisplay();
}

void parsekey_special(int key, int x, int y)
{
  switch (key)
    {
    case GLUT_KEY_UP: 
      rotations[objectMoving] += 0.02;
      break;
    case GLUT_KEY_DOWN:	 
      rotations[objectMoving] -= 0.02;
      break;
    case GLUT_KEY_RIGHT: 
      tmin += 0.02;
      if (tmin > 0.3) tmin = 0.3;
      break;
    case GLUT_KEY_LEFT:	
      tmin -= 0.02;
      if (tmin < 0) tmin = 0;
      break;
    default:
      return;
    }
  glutPostRedisplay();
}

void myReshape(int w, int h)
{
  int xmin, ymin;
  xmin = 0;
  ymin = 0;
  if (w > h) {
    xmin = (w-h)/2;
    w = h;
  } else {
    ymin = (h-w)/2;
    h = w;
  }
  width = w;
  height = h;
  glViewport(xmin, ymin, w, h);
  glutPostRedisplay();
}

void display(void)
{
  glPushMatrix();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  drawObject();

  glutSwapBuffers();
  glPopMatrix();
}

void myinit(void)
{
  glDepthRange (0.1, 10);

  glLoadIdentity();
  glClearColor(0.0, 0.0, 0.0, 1.0);
  rotations[0] = 0.0;
  rotations[1] = 0.0;
  rotations[2] = 0.0;
  length[0] = 0.7;
  length[1] = 0.5;
  length[2] = 0.5;
  objectMoving = TOP;
}

int main(int argc, char *argv[]) 
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE |
		      GLUT_STENCIL);
  glutCreateWindow("TD2");
  glutDisplayFunc(display);
  glutInitWindowSize(1200, 1200);
  glutInitWindowPosition(200, 0);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(parsekey);
  glutSpecialFunc(parsekey_special);
  glutReshapeFunc(myReshape);
  myinit();
    
  glutCreateMenu(handle_main_menu);
  glutAddMenuEntry("Moving the upper part of the arm", TOP);
  glutAddMenuEntry("Moving the middle of the arm", MIDDLE);
  glutAddMenuEntry("Moving the bottom of the arm", BOTTOM);
  glutAttachMenu(GLUT_RIGHT_BUTTON);
  glutSwapBuffers();
  glutMainLoop();
  return 0;
}
